<?php
/**
 * Test for mod: maestrosite-fix-DbPackages-*
 *
 */
if (!defined('SMF'))
{

	$dir = dirname(__FILE__);
	// If SSI.php is in the same place as this file,
	// and SMF isn't defined, this is being run standalone.
	if (file_exists($dir . '/SSI.php'))
		require_once( $dir . '/SSI.php');
	// one more...
	elseif (file_exists(dirname($dir) . '/SSI.php'))
		require_once( dirname($dir) . '/SSI.php');
	// subfolder in /Packages...?
	elseif (file_exists(dirname(dirname($dir)) . '/SSI.php'))
		require_once( dirname(dirname($dir)) . '/SSI.php');
	// Hmm... no SSI.php and no SMF?
	else
		die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

	if (!defined('SMF'))
		die('!!! ALARM !!!');
	db_extend('packages');
}
if( SMF != 'SSI' )
	return;

//
// setUp
//
//test table
$test_table = '{db_prefix}test_dbpackages_decimal';

//test data
$data = array(
	'a' => 0.01,
	'b' => 0.02,
	'c' => 0.3,
	'd' => 3.21,
);

//testing result
$result = array(
	'db_create_table' => 'skip',
	'db_change_column' => 'skip',
	'db_add_column' => 'skip',
);

global $smcFunc;

//insert test data set and get sum
function testSum($field, $data)
{
	global $smcFunc, $test_table;

	//insert data
	$smcFunc['db_query']('', 'INSERT INTO ' . $test_table . ' (' . $field. ') VALUES (' . implode('),(', $data) . ')');

	//fetch sum
	$request = $smcFunc['db_query']('', 'SELECT SUM(' . $field. ') AS ccc FROM ' . $test_table);
	$row = $smcFunc['db_fetch_assoc']($request);
	$sum = $row['ccc'];
	$smcFunc['db_free_result']($request);

	//expected data
	$exp = array_sum( $data );

	//erase testing data
	$request = $smcFunc['db_query']('truncate_table', 'TRUNCATE ' . $test_table);

	return ($sum == $exp) ? 'ok' : '<span style="color:red">Test failed!</span> Expected: ' . $exp . ' != result: ' . $sum;
}

//
//Test 1
//
$smcFunc['db_create_table']($test_table,
	array(
		array(
			'name' => 'sequence_number',
			'type' => 'tinyint',
			'unsigned' => true,
			'auto' => true,
		),
		array(
			'name' => 'price',
			'type' => 'decimal',
			'size' => '10,2',
			'unsigned' => true,
		),
		array(
			'name' => 'tax',
			'type' => 'tinyint',
		),
	),
	array(array(
		'type' => 'primary',
		'columns' => array('sequence_number'),
	)),
	array(),
	'owerwrite'
);
$result['db_create_table'] = testSum( 'price', $data );

//
//Test 2
//
$smcFunc['db_change_column']($test_table, 'tax',
	array(
		'type' => 'decimal',
		'size' => '10,2',
	)
);
$result['db_change_column'] = testSum( 'tax', $data );

//
//Test 3
//
$smcFunc['db_add_column']($test_table,
	array(
		'name' => 'fee',
		'type' => 'decimal',
		'size' => '10,2',
	)
);
$result['db_add_column'] = testSum( 'fee', $data );

//
//tearDown
//
//drop test table and print result
$smcFunc['db_drop_table']($test_table);
foreach( $result as $k => $v)
	echo $k, ' - ', $v, '<br />';
